/*
 * FTP/HTTP daemon
 * fhttpd-decls.h Copyright (C) 1995, 96, 97 Alex Belits
 *
 * This source/code is public free; you can distribute it and/or modify
 * it under terms of the GNU General Public License (published by the
 * Free Software Foundation) either version two of this License, or any
 * later version.
 *
 */

#ifndef INCLUDED_FHTTPD_DECLS_H
#define INCLUDED_FHTTPD_DECLS_H 1

#define FTPSERVER 21
#define WEBSERVER 80
#define PROCESSSERVER 8000
#define FTPTIMEOUT 900
#define HTTPTIMEOUT 120
#define MAXTRANSFERTIME 1800
#define MIN_CONNECTIONS_LEFT 10
#define MIN_CONNECTIONS_KEEPALIVE_LEFT 50

#define APP_MESSAGE_BUFFER_SIZE 16384
#define MESSAGE_BUFFER_SIZE     8192
#define WRITE_BUFFER_SIZE       4096

#define SERVERSOFTWARE "fhttpd/0.4.2"
#define GATEWAYINTERFACE "CGI/1.1"

#ifndef FHTTPD_CONFIG_FILE
#define FHTTPD_CONFIG_FILE "/etc/fhttpd.conf"
#endif

#ifndef FHTTPD_PID_FILE
#define FHTTPD_PID_FILE "/var/run/fhttpd.pid"
#endif

#ifndef MAX_CONTENT_LENGTH
#define MAX_CONTENT_LENGTH 1048576
#endif

#ifndef MAX_MESSAGE_SIZE
#define MAX_MESSAGE_SIZE 1048576
#endif

#ifndef MAX_TOTALSIZE
#define MAX_TOTALSIZE 1048576
#endif

#ifndef MAX_TOTALMESSAGESIZE
#define MAX_TOTALMESSAGESIZE 1048576
#endif

#ifndef FHTTPD_HTTP_USER
#define FHTTPD_HTTP_USER "ftp"
#endif

#ifndef SIGARGS
#define SIGARGS int sig
#endif
#ifndef SIGACTARGS
#define SIGACTARGS int sig
#endif

#define FHTTPD_REQUEST       1
#define FHTTPD_DISCONNECT    2
#define FHTTPD_ACK           3
#define FHTTPD_EXITOK        4
#define FHTTPD_LOG_REQUEST   5

#define FHTTPD_FINISH        0
#define FHTTPD_SEND          1
#define FHTTPD_INST_SELECT   2
#define FHTTPD_INST_DESELECT 3
#define FHTTPD_INST_CAP      4
#define FHTTPD_FINISH_DROP   5
#define FHTTPD_INST_EXITREQ  6
#define FHTTPD_LOG_MESSAGE   7

#define APP_CAP_KEEPALIVE    1
#define APP_CAP_ACKFINISH    2

enum{
NORESOLVE,HONORKEEPALIVE,HTTPPORT,FTPPORT,PROCESSPORT,
STORMODE,ABSSTORMODE,MKDMODE,ABSMKDMODE,INBOUND,ABSINBOUND,PIPEINEXEC,
ABSPIPEINEXEC,
PIPEOUTEXEC,ABSPIPEOUTEXEC,
DEFAULTHEADER,DEFAULTFOOTER,C_TYPE,C_ABSTYPE,C_DIRTYPE,C_ABSDIRTYPE,
GETRULE,ABSGETRULE,EXECMASK,SPECIALEXECMASK,
ACCESSREALM,ACCESSRIGHTS,
PRELOAD,HTTPROOT,ADDRESSROOT,APPLICATION,AUTHAPPLICATION,LOGAPPLICATION,UMASK,
MAXCONTENTLENGTH,MAXMESSAGESIZE,MAXDATAINQUEUE,MAXDATAINLOGQUEUE,USERDIR,
MAPUSERDIR,NCONFIGCOMMANDS};

#endif
